#import "MFi_SPPAppDelegate.h"
#import "MFi_SPPViewController.h"
#import <ExternalAccessory/ExternalAccessory.h>

@interface MFi_SPPAppDelegate(viPrivate)
- (EAAccessory *)obtainAccessoryForProtocol:(NSString *)protocolString;
@end

@implementation MFi_SPPAppDelegate

@synthesize window;
@synthesize viewController;

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {    
    NSLog(@"didFinishLaunchingWithOptions");
    NSLog(@"self ' class is %@", [self class]); 
	[[EAAccessoryManager sharedAccessoryManager] registerForLocalNotifications];
    
	[window addSubview:viewController.view];
	viewController.accessory = [self obtainAccessoryForProtocol:MFi_SPP_Protocol];

	[[NSNotificationCenter defaultCenter] addObserver:self 
											 selector:@selector(acessoryDidConnectNotification:) 
												 name:EAAccessoryDidConnectNotification 
											   object:NULL];
	
    [window makeKeyAndVisible];
    return YES;
}

- (void)applicationWillResignActive:(UIApplication *)application {
    /*
     Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
     Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
     */
}

- (void)applicationDidEnterBackground:(UIApplication *)application {
    /*
     Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
     If your application supports background execution, called instead of applicationWillTerminate: when the user quits.
     */
}

- (void)applicationWillEnterForeground:(UIApplication *)application {
    /*
     Called as part of  transition from the background to the inactive state: here you can undo many of the changes made on entering the background.
     */
}

- (void)applicationDidBecomeActive:(UIApplication *)application {
    /*
     Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
     */
}

- (void)applicationWillTerminate:(UIApplication *)application {
    /*
     Called when the application is about to terminate.
     See also applicationDidEnterBackground:.
     */
    NSLog(@"applicationWillTerminate");
	[[EAAccessoryManager sharedAccessoryManager] unregisterForLocalNotifications];
	viewController.accessory = NULL;
}


- (void)applicationDidReceiveMemoryWarning:(UIApplication *)application {
    /*
     Free up as much memory as possible by purging cached data objects that can be recreated (or reloaded from disk) later.
     */
}


- (void)dealloc {
	[[NSNotificationCenter defaultCenter] removeObserver:self];
    [viewController release];
    [window release];
    [super dealloc];
}
- (EAAccessory *)obtainAccessoryForProtocol:(NSString *)protocolString
{
    NSLog(@"obtainAccessoryForProtocol");
    NSArray *accessories = [[EAAccessoryManager sharedAccessoryManager]
							connectedAccessories];
//	NSLog(@"connectedAccessories:%@", accessories);
    EAAccessory *accessory = nil;
   
    for (EAAccessory *obj in accessories) {
        if ([[obj protocolStrings] containsObject:protocolString]) {
            accessory = obj;
            break;
        }
    }
	
    return accessory;
}
- (void)acessoryDidConnectNotification:(NSNotification *)notification {
    NSLog(@"acessoryDidConnectNotification");

	if (viewController.accessory == NULL) {
		viewController.accessory = [self obtainAccessoryForProtocol:MFi_SPP_Protocol];
	}
}
@end
